package Program::Perl;

# Since only perl can parse Perl, this is incomplete.

use strict;
use vars qw/$VERSION @ISA @EXPORT/;

require Exporter;
require AutoLoader;
require Program;
require Program::Statement;

@ISA = qw(Exporter AutoLoader Program);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw//;
$VERSION = '0.01';

require Program::Statement;

# Preloaded methods go here.

sub new {
    my $that = shift;
    my $class = ref($that) || $that;
    my $self = {
	Program_name => shift,
	First_statement => undef,
	Current_statement => undef,
	Language => 'Perl',
	Text => undef
    };
    bless $self, $class;
    return $self;
}

sub parse {
    my $self = shift;
    $self->{First_statement} = Program::Statement->new();
    $self->{Current_statement} = $self->{First_statement};
    local $_ = $self->{Text};
    my @brackets = ();
    while(/("((?:\\.|\$.|[^"])*)"|`((?:\\.|\$.|[^`])*)`|'((?:\\.|[^'])*)'|#.*?\n|^=(?!cut)(.*?)^=cut\s*?\n|\w+|.)/smg) { #"{
	my $statement = $self->{Current_statement};
	my $found = $1;

	if ($found =~ /^["`']/) { #"{
            $statement->add_quoted_code($found);
	}
        elsif ($found =~ /^#((?:\\.|[^\n])*)\n$/s) { #"
            $statement->add_comment($1);
	    $statement->add_code(' ');
        }
        elsif ($found =~ /^=(?!cut)(.*?)^=cut\s*?\n$/sm) {
	    $statement->add_description($1);
	}
        else {
            # Account for the fact that [ may start a "block" later.
            if ($found eq '(' or $found eq '[') {
		push @brackets, $found;
		$statement->add_code($found);
            }
	    elsif (@brackets) {	# If there are remaining open brackets,
				# the statement isn't complete.
		$statement->add_code($found);
                # Check @brackets later on to see if the brackets match.
                pop @brackets
                   if $found eq '}' or $found eq ']' or $found eq ')';
                push @brackets, $found if $found eq '{';
            }
	    elsif ($found eq ';') {
		$self->{Current_statement} = $statement->next_statement;
	    }
            elsif($found eq '{') {
		$self->{Current_statement} = $statement->up;
 	    }
            elsif($found eq '}') {
		if (ref $statement->get_down) {
                    $self->{Current_statement} = $statement->last_statement;
                }
                else {		# Mismatched brackets; soldier on...
		    $self->{Current_statement} = $statement->next_statement;
                }
 	    }
            else {
		$statement->add_code($found);
            }
        }
	$statement->add_text($found);
    }
}

sub stmt_is_subr {
    my ($self, $statement) = @_;
    if (!(ref $statement->get_down) and
	$statement->get_code =~ /^sub (\w+)/) {
	return $1;
    }
    return undef;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Program::Perl - A Perl program

=head1 SYNOPSIS

Program ...

=head1 DESCRIPTION

Program

=head1 BUGS

The documentation for this module is incomplete.

=head1 AUTHOR

James Yolkowski

=head1 SEE ALSO

perl(1).

=cut
